//---------------------------------------------------------------------------
#pragma hdrstop

#include "Unit1.h"

#include "HDDPhysic_defs.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
HINSTANCE hHDDPhysicDllInst = NULL;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  //init
  hHDDPhysicDllInst = LoadLibrary("HDDPhysic.dll");
  if (!hHDDPhysicDllInst)
   hHDDPhysicDllInst = LoadLibrary("../HDDPhysic.dll");

  if (!hHDDPhysicDllInst)
  {
    Button2->Enabled=false;
    MessageBox(GetActiveWindow(),"Can't find HDDPhysic.dll, make sure is in the same folder as this exe","HDDPhysic.dll not found",MB_OK|MB_ICONERROR);
   }
  else
  {
	  HDDPhysic_Init     = (fHDDPhysicInit)   GetProcAddress(hHDDPhysicDllInst,"Init");
	  HDDPhysic_GetInfo  = (fHDDPhysicGetInfo)GetProcAddress(hHDDPhysicDllInst,"GetPhysicInfo");

          int dCount=HDDPhysic_Init("your reg info here","your reg info here"); 
          if (dCount==0) //nothing found (this should never happen, but just in case it does)
             Button2->Enabled=false;
          else
           {
             for (int i=0; i<dCount;i++)
              {
                CmbDrive->Items->Add(AnsiString(i));
              }
             CmbDrive->ItemIndex=0;
             //Get Windows hdd drive location
             Edit7->Text = HDDPhysic_GetInfo(0, 6,NULL);
           }
  }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
    char buff[1024]={0};

    //Get SerialNumber
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 0,buff) > 0)
      Edit1->Text = buff;
    else
      Edit1->Text ="n/a";


    //Get ModelNumber
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 1,buff) > 0)
      Edit2->Text = buff;
    else
      Edit2->Text ="n/a";

    //Get RevisionNo
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 2,buff) > 0)
      Edit3->Text = buff;
    else
      Edit3->Text ="n/a";

    //Get type
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 3,buff) > 0)
      Edit6->Text = buff;
    else
      Edit6->Text ="n/a";


    //Get Drive Size
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 4,buff) > 0)
      Edit5->Text = buff;
    else
      Edit5->Text ="n/a";


    //Get Buffer Size
    if(HDDPhysic_GetInfo(atoi(CmbDrive->Items->operator [](CmbDrive->ItemIndex).c_str()), 5,buff) > 0)
      Edit4->Text = buff;
    else
      Edit4->Text ="n/a";




    /*/Call Buffer Size
    Edit4->Text = GetBufferSize(iDrive, RegCode);
      */

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if ( hHDDPhysicDllInst ) FreeLibrary (hHDDPhysicDllInst);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Label10Click(TObject *Sender)
{
  ShellExecute(GetActiveWindow(),"Open","http://www.rlbyte.com","","C:\\",SW_SHOW);        
}
//---------------------------------------------------------------------------

