﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace HDDPhysic_Example
{
    public partial class Form1 : Form
    {
        [DllImport("HDDPhysic")]
        public static extern int Init(string sUser, string sRegCode);

        [DllImport("HDDPhysic")]
        public static extern int GetPhysicInfo(int diskIndex, int InfoType, StringBuilder pHddInfo);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            const int nChars = 1024;
            StringBuilder Buff = new StringBuilder(nChars);
            
            //Get SerialNumber
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 0, Buff) > 0)
                textBox2.Text = Buff.ToString();
            else
                textBox2.Text = "n/a";

            //Get ModelNumber
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 1, Buff) > 0)
                textBox3.Text = Buff.ToString();
            else
                textBox3.Text = "n/a";

            //Get RevisionNo
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 2, Buff) > 0)
                textBox4.Text = Buff.ToString();
            else
                textBox4.Text = "n/a";

            //Get type
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 3, Buff) > 0)
                textBox1.Text = Buff.ToString();
            else
                textBox1.Text = "n/a";

            //Get Drive Size
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 4, Buff) > 0)
                textBox6.Text = Buff.ToString();
            else
                textBox6.Text = "n/a";

            //Get Buffer Size
            if (GetPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 5, Buff) > 0)
                textBox5.Text = Buff.ToString();
            else
                textBox5.Text = "n/a";
            
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int dCount = Init("MyEmail", "MySerial");
            if (dCount == 0) //nothing found (this should never happen, but just in case it does)
                button1.Enabled = false;
            else
            {
                for (int i = 0; i < dCount; i++)
                {
                    comboBox1.Items.Add(i.ToString());
                }
                comboBox1.SelectedIndex = 0;
                textBox7.Text = GetPhysicInfo(0, 6, null).ToString();
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("IExplore", " http://www.rlbyte.com");
        }
    }
}
